package jhc;

import java.lang.Double;

/** Perform routine coordinate conversion tasks. */
public class Coordinate {

    /** Eventually, this method should take coordinates and output converted
      * coordinates. */
    public static void main(String[] args) {
        double h = (new Double(args[0])).doubleValue();
        double m = (new Double(args[1])).doubleValue();
        double s = (new Double(args[2])).doubleValue();
        double d = (new Double(args[3])).doubleValue();
        double am= (new Double(args[4])).doubleValue();
        double as= (new Double(args[5])).doubleValue();        
        try {
            double ra = hms2deg(h, m, s);
            double dec= dms2deg(d, am, as);
            System.out.printf("%f, %f%n", ra, dec);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    /** Convert RA in H:M:S format to decimal degrees. */
    public static double hms2deg(double h, double m, double s) throws Exception {
        if ( h < 0 || h > 24 ||
             m < 0 || m > 60 ||
             s < 0 || s > 60 ) throw new Exception("Unexpected H:M:S input.");
        double deg = ( ( ( ( s / 60.0d ) + m ) / 60.0d ) + h ) * 360.0d / 24.0d;
        return deg;
    }

    /** Convert Dec in D:M:S format to decimal degrees. */
    public static double dms2deg(double d, double m, double s) throws Exception {
        if ( d < -90 || d > 90 ||
             m < 0   || m > 60 ||
             s < 0   || s > 60 ) throw new Exception("Unexpected D:M:S input.");
        // If d is less than zero or is negative zero, then m and s are 
        // implicitly negative.
        if ( d < 0 || (new Double(d)).compareTo(new Double(-0.0d)) == 0 ) {
            m = m * -1;
            s = s * -1;
        }
        double deg = ( ( ( s / 60.0d ) + m ) / 60.0d ) + d;
        return deg;
    }

}