/* Constructor for Links object. 
 * This object provides methods for creating and placing links into the DataTable.
 *
 * THIS FILE IS NOT CURRENTLY BEING USED AND WILL BE REMOVED.
 * 
 
 */

function Links( oDataTable ) 
{

    var that = this; // make object accessible to methods
    
    /* PUBLIC FIELDS */
    
    this.bImagesPresent;

    /* PRIVATE FIELDS */
    
    var oDataTable = oDataTable;
    var aasData = oDataTable.fnGetData();
    var asColTitles = fnCreateTitleArray();
    //console.log("asColTitles = " + asColTitles);
    var iImageColIndex = fnGetImageColIndex();
    //console.log("iImageColIndex = " + iImageColIndex);
    var aiImageRowIndices = fnGetRowsWithImages();
    //console.log("aiImageRowIndices = " + aiImageRowIndices);
    //console.log(fnCreateImageURL(aasData[aiImageRowIndices[1]]));
    
    
    /* Return the index of the image column */
    function fnGetImageColIndex()
    {
        // For VLA Obs Summary table
        return $.inArray( "n_images", asColTitles );
    }
    
    /* Identify table rows that contain images 
     * Return an array of indices to the fnGetData() array; these indices point to rows in the data table where images are present.
     */
    function fnGetRowsWithImages()
    {
        var aiImageRowIndices = [];
        var i = 0; // index
        var j = 0; // index
        for ( i = 0; i < aasData.length; i++ )
        {
            if ( aasData[i][ iImageColIndex ] != 0 )
            {
                // Images are present, so add row index to array
                aiImageRowIndices[j] = i;
                j++;
            }
        }
        return aiImageRowIndices;
    }

    this.fnCIURL = function ( asRow ) 
    {
        return fnCreateImageURL(asRow);
    };
    
    /* Form URL that links to images for this row. 
     */
    function fnCreateImageURL( asRow )
    {
        var sURL = "https://archive.nrao.edu/archive/ArchiveRouter?"
        // Get starttime, minus 1 day
        var fStartTime = parseFloat( fnGetDatum("starttime") ) - 1;
        // Get stoptime, plus 1 day
        var fStopTime = parseFloat( fnGetDatum("stoptime") ) + 1;
        sURL = sURL + "IMAGE_PARMS=VLA" + "%2C" // archive
            + fnGetDatum( "project_code" ) + "%2C" // project code
            + fnGetDatum( "if_band" ) + "%2C" // band letter
            + fStartTime + "%2C" // start time
            + fStopTime + "%2C" // stop time
            + fnGetDatum( "radeg" ) + "%2C" // ra degrees
            + fnGetDatum( "decdeg" ) + "%2C" // dec degrees
            + "0.01" // search radius
        
        return sURL;
        
        /* Return row datum, given a column title */
        function fnGetDatum( title ) {
            var iIndex = $.inArray( title, asColTitles );
            return asRow[ iIndex ];
        }
    }
    
    /* Place image URL into table */
    function fnAddImageLinks()
    {
        var i = 0; // index
        for ( i = 0; i < aiImageRowIndices.length; i++ )
        {
            var asRow = aasData[ aiImageRowIndices[ i ] ];
            var sText = asRow[ iImageColIndex ];
            var linkHTML = "<a href='"  + fnCreateImageURL( asRow ) + "' "
                            + "target='_blank' >"
                            + sText + "</a>";
            oDataTable.fnUpdate( linkHTML, aiImageRowIndices[ i ], iImageColIndex );
        }
    }

    /* Return an array of column header titles */
    function fnCreateTitleArray()
    {
        var asColTitles = [];
        var i = 0; // index
        $(oDataTable.fnSettings().aoColumns).each( function ()
        {
            asColTitles[i] = this.sTitle;
            i++;
        });
        return asColTitles;
    }

    /* BEGIN CONSTRUCTOR */
    
    this.bImagesPresent = ( aiImageRowIndices.length > 0 ) ? true : false;
    if ( this.bImagesPresent ) { fnAddImageLinks(); }
    
    return;

}